<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.12.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmCommon: X:/kmCommonDefs.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">kmCommon
   </div>
   <div id="projectbrief">kmCommon library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.12.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search',true);
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('km_common_defs_8h.html',''); initResizable(true); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a>  </div>
  <div class="headertitle"><div class="title">X:/kmCommonDefs.h File Reference</div></div>
</div><!--header-->
<div class="contents">

<p>Useful macros for value manipulation and calculations. Constants and conversion factors for use in time and bit manipulation.  
<a href="#details">More...</a></p>

<p><a href="km_common_defs_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="define-members" name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:aae9131e49e1a70ddd3553c9675f5ffcb" id="r_aae9131e49e1a70ddd3553c9675f5ffcb"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aae9131e49e1a70ddd3553c9675f5ffcb">KMC_VALUE_TO_STRING</a>(x)</td></tr>
<tr class="memdesc:aae9131e49e1a70ddd3553c9675f5ffcb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Converts a value to its string representation.  <br /></td></tr>
<tr class="separator:aae9131e49e1a70ddd3553c9675f5ffcb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad80e356747d976a14f58ae2cd88bd75e" id="r_ad80e356747d976a14f58ae2cd88bd75e"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#ad80e356747d976a14f58ae2cd88bd75e">KMC_VALUE</a>(x)</td></tr>
<tr class="memdesc:ad80e356747d976a14f58ae2cd88bd75e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Macro to get the string representation of a value.  <br /></td></tr>
<tr class="separator:ad80e356747d976a14f58ae2cd88bd75e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a324c0391d0bbdc4ae0e89bbf2a12304d" id="r_a324c0391d0bbdc4ae0e89bbf2a12304d"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a324c0391d0bbdc4ae0e89bbf2a12304d">KMC_VAR_NAME_VALUE</a>(var)</td></tr>
<tr class="memdesc:a324c0391d0bbdc4ae0e89bbf2a12304d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Macro to get a variable name and its value as a string.  <br /></td></tr>
<tr class="separator:a324c0391d0bbdc4ae0e89bbf2a12304d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4ae2bd7db4825524ef32840b10ed3ff" id="r_af4ae2bd7db4825524ef32840b10ed3ff"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#af4ae2bd7db4825524ef32840b10ed3ff">KMC_MIN</a>(A,  B)</td></tr>
<tr class="memdesc:af4ae2bd7db4825524ef32840b10ed3ff"><td class="mdescLeft">&#160;</td><td class="mdescRight">Macro to find the minimum of two values.  <br /></td></tr>
<tr class="separator:af4ae2bd7db4825524ef32840b10ed3ff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc81a21527ba9134193dd6edc7a714a1" id="r_adc81a21527ba9134193dd6edc7a714a1"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#adc81a21527ba9134193dd6edc7a714a1">KMC_MAX</a>(A,  B)</td></tr>
<tr class="memdesc:adc81a21527ba9134193dd6edc7a714a1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Macro to find the maximum of two values.  <br /></td></tr>
<tr class="separator:adc81a21527ba9134193dd6edc7a714a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adee3c57f4c636e61dcc0d405188b54b2" id="r_adee3c57f4c636e61dcc0d405188b54b2"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#adee3c57f4c636e61dcc0d405188b54b2">KMC_CLAMP</a>(x,  low,  high)</td></tr>
<tr class="memdesc:adee3c57f4c636e61dcc0d405188b54b2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Macro to clamp a value within a specified range.  <br /></td></tr>
<tr class="separator:adee3c57f4c636e61dcc0d405188b54b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f1271bf1276df4fb7883ea6eaeafbc8" id="r_a6f1271bf1276df4fb7883ea6eaeafbc8"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a6f1271bf1276df4fb7883ea6eaeafbc8">KMC_ARRAY_SIZE</a>(a)</td></tr>
<tr class="memdesc:a6f1271bf1276df4fb7883ea6eaeafbc8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the number of elements in a static array.  <br /></td></tr>
<tr class="separator:a6f1271bf1276df4fb7883ea6eaeafbc8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7e307660f3dff077b1062a0589df4b5" id="r_aa7e307660f3dff077b1062a0589df4b5"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aa7e307660f3dff077b1062a0589df4b5">KMC_UINT8_TO_BINARY_STRING</a>(byte)</td></tr>
<tr class="memdesc:aa7e307660f3dff077b1062a0589df4b5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a uint8_t value to a binary string.  <br /></td></tr>
<tr class="separator:aa7e307660f3dff077b1062a0589df4b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74dd4d6ddaafe8bfa3cf7abd7fea92ff" id="r_a74dd4d6ddaafe8bfa3cf7abd7fea92ff"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a74dd4d6ddaafe8bfa3cf7abd7fea92ff">KMC_UINT16_TO_BINARY_STRING</a>(byte)</td></tr>
<tr class="memdesc:a74dd4d6ddaafe8bfa3cf7abd7fea92ff"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a uint16_t value to a binary string.  <br /></td></tr>
<tr class="separator:a74dd4d6ddaafe8bfa3cf7abd7fea92ff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61c999240e2e2e0cfa0871cbbed7d23e" id="r_a61c999240e2e2e0cfa0871cbbed7d23e"><td class="memItemLeft" align="right" valign="top"><a id="a61c999240e2e2e0cfa0871cbbed7d23e" name="a61c999240e2e2e0cfa0871cbbed7d23e"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_SIGNED_ZERO</b>&#160;&#160;&#160;0x00u</td></tr>
<tr class="separator:a61c999240e2e2e0cfa0871cbbed7d23e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a31a907ad6c4742a1819ab3d1ddcb0f9d" id="r_a31a907ad6c4742a1819ab3d1ddcb0f9d"><td class="memItemLeft" align="right" valign="top"><a id="a31a907ad6c4742a1819ab3d1ddcb0f9d" name="a31a907ad6c4742a1819ab3d1ddcb0f9d"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_UNSIGNED_ZERO</b>&#160;&#160;&#160;0x00u</td></tr>
<tr class="memdesc:a31a907ad6c4742a1819ab3d1ddcb0f9d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing the unsigned value ZERO. <br /></td></tr>
<tr class="separator:a31a907ad6c4742a1819ab3d1ddcb0f9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90345e592de3ffc92c261003fb687e56" id="r_a90345e592de3ffc92c261003fb687e56"><td class="memItemLeft" align="right" valign="top"><a id="a90345e592de3ffc92c261003fb687e56" name="a90345e592de3ffc92c261003fb687e56"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_INDEX_ZERO</b>&#160;&#160;&#160;<a class="el" href="#a31a907ad6c4742a1819ab3d1ddcb0f9d">KMC_UNSIGNED_ZERO</a></td></tr>
<tr class="memdesc:a90345e592de3ffc92c261003fb687e56"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing the initial index for loops. <br /></td></tr>
<tr class="separator:a90345e592de3ffc92c261003fb687e56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd89b93a847765587148ab96a7dca129" id="r_abd89b93a847765587148ab96a7dca129"><td class="memItemLeft" align="right" valign="top"><a id="abd89b93a847765587148ab96a7dca129" name="abd89b93a847765587148ab96a7dca129"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_UNSIGNED_ONE</b>&#160;&#160;&#160;0x01u</td></tr>
<tr class="memdesc:abd89b93a847765587148ab96a7dca129"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing the unsigned value one. <br /></td></tr>
<tr class="separator:abd89b93a847765587148ab96a7dca129"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac83447179a3c515afc75b6a0f68414b1" id="r_ac83447179a3c515afc75b6a0f68414b1"><td class="memItemLeft" align="right" valign="top"><a id="ac83447179a3c515afc75b6a0f68414b1" name="ac83447179a3c515afc75b6a0f68414b1"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_SIGNED_ONE</b>&#160;&#160;&#160;0x01</td></tr>
<tr class="memdesc:ac83447179a3c515afc75b6a0f68414b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing the signed value one. <br /></td></tr>
<tr class="separator:ac83447179a3c515afc75b6a0f68414b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac329999bc8534ac2e434397d8f5dc6f" id="r_aac329999bc8534ac2e434397d8f5dc6f"><td class="memItemLeft" align="right" valign="top"><a id="aac329999bc8534ac2e434397d8f5dc6f" name="aac329999bc8534ac2e434397d8f5dc6f"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_SIGNED_MINUS_ONE</b>&#160;&#160;&#160;-1</td></tr>
<tr class="memdesc:aac329999bc8534ac2e434397d8f5dc6f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing the signed value minus one. <br /></td></tr>
<tr class="separator:aac329999bc8534ac2e434397d8f5dc6f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a8f4239c5ad41602c910e30c6733b09" id="r_a7a8f4239c5ad41602c910e30c6733b09"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a7a8f4239c5ad41602c910e30c6733b09">KMC_INDEX_INCREASE</a>&#160;&#160;&#160;0x01u</td></tr>
<tr class="memdesc:a7a8f4239c5ad41602c910e30c6733b09"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing the unsigned value one used to increase index.  <br /></td></tr>
<tr class="separator:a7a8f4239c5ad41602c910e30c6733b09"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e8b1f645dd3292273579bf45c035202" id="r_a2e8b1f645dd3292273579bf45c035202"><td class="memItemLeft" align="right" valign="top"><a id="a2e8b1f645dd3292273579bf45c035202" name="a2e8b1f645dd3292273579bf45c035202"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_INDEX_DECREASE</b>&#160;&#160;&#160;0x01u</td></tr>
<tr class="separator:a2e8b1f645dd3292273579bf45c035202"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8cda6c6e797c1b5cf0d741b1fe07195" id="r_ad8cda6c6e797c1b5cf0d741b1fe07195"><td class="memItemLeft" align="right" valign="top"><a id="ad8cda6c6e797c1b5cf0d741b1fe07195" name="ad8cda6c6e797c1b5cf0d741b1fe07195"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_ALL_BITS_CLEARED</b>&#160;&#160;&#160;0x00u</td></tr>
<tr class="memdesc:ad8cda6c6e797c1b5cf0d741b1fe07195"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing all bits cleared (zeroed). <br /></td></tr>
<tr class="separator:ad8cda6c6e797c1b5cf0d741b1fe07195"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af581a18e71b623e7ec68bd5b8f970943" id="r_af581a18e71b623e7ec68bd5b8f970943"><td class="memItemLeft" align="right" valign="top"><a id="af581a18e71b623e7ec68bd5b8f970943" name="af581a18e71b623e7ec68bd5b8f970943"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_4_OUT_OF_8_BIT_MASK_LO</b>&#160;&#160;&#160;0x0fu</td></tr>
<tr class="memdesc:af581a18e71b623e7ec68bd5b8f970943"><td class="mdescLeft">&#160;</td><td class="mdescRight">4 out of 8 bits mask for the low nibble (4 bits). <br /></td></tr>
<tr class="separator:af581a18e71b623e7ec68bd5b8f970943"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab5ba6b0fcc6b8a6a69def0c5518f10c" id="r_aab5ba6b0fcc6b8a6a69def0c5518f10c"><td class="memItemLeft" align="right" valign="top"><a id="aab5ba6b0fcc6b8a6a69def0c5518f10c" name="aab5ba6b0fcc6b8a6a69def0c5518f10c"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_4_OUT_OF_8_BIT_MASK_HI</b>&#160;&#160;&#160;0xf0u</td></tr>
<tr class="memdesc:aab5ba6b0fcc6b8a6a69def0c5518f10c"><td class="mdescLeft">&#160;</td><td class="mdescRight">4 out of 8 bits mask for the high nibble (4 bits). <br /></td></tr>
<tr class="separator:aab5ba6b0fcc6b8a6a69def0c5518f10c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a063598fd9b2c6e76ce678a294cb52421" id="r_a063598fd9b2c6e76ce678a294cb52421"><td class="memItemLeft" align="right" valign="top"><a id="a063598fd9b2c6e76ce678a294cb52421" name="a063598fd9b2c6e76ce678a294cb52421"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_7_OUT_OF_16_BIT_MASK_LO</b>&#160;&#160;&#160;0x7fu</td></tr>
<tr class="memdesc:a063598fd9b2c6e76ce678a294cb52421"><td class="mdescLeft">&#160;</td><td class="mdescRight">7 out of 16 bits mask for the low byte signed value (7 bits). <br /></td></tr>
<tr class="separator:a063598fd9b2c6e76ce678a294cb52421"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a268882398039ffbf99d61e83f0e7782d" id="r_a268882398039ffbf99d61e83f0e7782d"><td class="memItemLeft" align="right" valign="top"><a id="a268882398039ffbf99d61e83f0e7782d" name="a268882398039ffbf99d61e83f0e7782d"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_8_OUT_OF_16_BIT_MASK_LO</b>&#160;&#160;&#160;0xffu</td></tr>
<tr class="memdesc:a268882398039ffbf99d61e83f0e7782d"><td class="mdescLeft">&#160;</td><td class="mdescRight">8 out of 16 bits mask for the low byte (8 bits). <br /></td></tr>
<tr class="separator:a268882398039ffbf99d61e83f0e7782d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6fbe1e63402cf99533794d1cc25e2a34" id="r_a6fbe1e63402cf99533794d1cc25e2a34"><td class="memItemLeft" align="right" valign="top"><a id="a6fbe1e63402cf99533794d1cc25e2a34" name="a6fbe1e63402cf99533794d1cc25e2a34"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_8_OUT_OF_16_BIT_MASK_HI</b>&#160;&#160;&#160;0xff00u</td></tr>
<tr class="memdesc:a6fbe1e63402cf99533794d1cc25e2a34"><td class="mdescLeft">&#160;</td><td class="mdescRight">8 out of 16 bits mask for the high byte (8 bits). <br /></td></tr>
<tr class="separator:a6fbe1e63402cf99533794d1cc25e2a34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbc54dae08ff5d12972cb5a47362cdc7" id="r_abbc54dae08ff5d12972cb5a47362cdc7"><td class="memItemLeft" align="right" valign="top"><a id="abbc54dae08ff5d12972cb5a47362cdc7" name="abbc54dae08ff5d12972cb5a47362cdc7"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_16_OUT_OF_32_BIT_MASK_LO</b>&#160;&#160;&#160;0xffffu</td></tr>
<tr class="memdesc:abbc54dae08ff5d12972cb5a47362cdc7"><td class="mdescLeft">&#160;</td><td class="mdescRight">16 out of 32 bits mask for the low byte (8 bits). <br /></td></tr>
<tr class="separator:abbc54dae08ff5d12972cb5a47362cdc7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4346e2d3b548200f6cb0b5334eeaba89" id="r_a4346e2d3b548200f6cb0b5334eeaba89"><td class="memItemLeft" align="right" valign="top"><a id="a4346e2d3b548200f6cb0b5334eeaba89" name="a4346e2d3b548200f6cb0b5334eeaba89"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_16_OUT_OF_32_BIT_MASK_HI</b>&#160;&#160;&#160;0xffff0000u</td></tr>
<tr class="memdesc:a4346e2d3b548200f6cb0b5334eeaba89"><td class="mdescLeft">&#160;</td><td class="mdescRight">16 out of 32 bits mask for the high byte (8 bits). <br /></td></tr>
<tr class="separator:a4346e2d3b548200f6cb0b5334eeaba89"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec333388124cb6af61b42e7b0c9665bf" id="r_aec333388124cb6af61b42e7b0c9665bf"><td class="memItemLeft" align="right" valign="top"><a id="aec333388124cb6af61b42e7b0c9665bf" name="aec333388124cb6af61b42e7b0c9665bf"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_7_BIT_SHIFT</b>&#160;&#160;&#160;0x07u</td></tr>
<tr class="memdesc:aec333388124cb6af61b42e7b0c9665bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shift value of 9 bits. <br /></td></tr>
<tr class="separator:aec333388124cb6af61b42e7b0c9665bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a76ffb72523be056eb871dccd9ccdbd58" id="r_a76ffb72523be056eb871dccd9ccdbd58"><td class="memItemLeft" align="right" valign="top"><a id="a76ffb72523be056eb871dccd9ccdbd58" name="a76ffb72523be056eb871dccd9ccdbd58"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_8_BIT_SHIFT</b>&#160;&#160;&#160;0x08u</td></tr>
<tr class="memdesc:a76ffb72523be056eb871dccd9ccdbd58"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shift value of 8 bits. <br /></td></tr>
<tr class="separator:a76ffb72523be056eb871dccd9ccdbd58"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad03e031783cbc0ec6bec499cf61742fb" id="r_ad03e031783cbc0ec6bec499cf61742fb"><td class="memItemLeft" align="right" valign="top"><a id="ad03e031783cbc0ec6bec499cf61742fb" name="ad03e031783cbc0ec6bec499cf61742fb"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_9_BIT_SHIFT</b>&#160;&#160;&#160;0x09u</td></tr>
<tr class="memdesc:ad03e031783cbc0ec6bec499cf61742fb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shift value of 9 bits. <br /></td></tr>
<tr class="separator:ad03e031783cbc0ec6bec499cf61742fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a214a2a4ff84bd9ab6e5d823e82b99d69" id="r_a214a2a4ff84bd9ab6e5d823e82b99d69"><td class="memItemLeft" align="right" valign="top"><a id="a214a2a4ff84bd9ab6e5d823e82b99d69" name="a214a2a4ff84bd9ab6e5d823e82b99d69"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_4_BIT_SHIFT</b>&#160;&#160;&#160;0x04u</td></tr>
<tr class="memdesc:a214a2a4ff84bd9ab6e5d823e82b99d69"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shift value of 4 bits. <br /></td></tr>
<tr class="separator:a214a2a4ff84bd9ab6e5d823e82b99d69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b598e7bfe6c68cc1eb3d0f88bba2fbc" id="r_a3b598e7bfe6c68cc1eb3d0f88bba2fbc"><td class="memItemLeft" align="right" valign="top"><a id="a3b598e7bfe6c68cc1eb3d0f88bba2fbc" name="a3b598e7bfe6c68cc1eb3d0f88bba2fbc"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_1_BIT_SHIFT</b>&#160;&#160;&#160;0x01u</td></tr>
<tr class="memdesc:a3b598e7bfe6c68cc1eb3d0f88bba2fbc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shift value of 1 bit. <br /></td></tr>
<tr class="separator:a3b598e7bfe6c68cc1eb3d0f88bba2fbc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b75ba9c33ed93a082dbcd0d82ced0c9" id="r_a6b75ba9c33ed93a082dbcd0d82ced0c9"><td class="memItemLeft" align="right" valign="top"><a id="a6b75ba9c33ed93a082dbcd0d82ced0c9" name="a6b75ba9c33ed93a082dbcd0d82ced0c9"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_2</b>&#160;&#160;&#160;0x01u</td></tr>
<tr class="memdesc:a6b75ba9c33ed93a082dbcd0d82ced0c9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 1bit right shift (division by 2). <br /></td></tr>
<tr class="separator:a6b75ba9c33ed93a082dbcd0d82ced0c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a196281f559a94d97864d05594be4f0c3" id="r_a196281f559a94d97864d05594be4f0c3"><td class="memItemLeft" align="right" valign="top"><a id="a196281f559a94d97864d05594be4f0c3" name="a196281f559a94d97864d05594be4f0c3"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_4</b>&#160;&#160;&#160;0x02u</td></tr>
<tr class="memdesc:a196281f559a94d97864d05594be4f0c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 2bit right shift (division by 4). <br /></td></tr>
<tr class="separator:a196281f559a94d97864d05594be4f0c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac730e2a8665f393221200717e97044b0" id="r_ac730e2a8665f393221200717e97044b0"><td class="memItemLeft" align="right" valign="top"><a id="ac730e2a8665f393221200717e97044b0" name="ac730e2a8665f393221200717e97044b0"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_8</b>&#160;&#160;&#160;0x03u</td></tr>
<tr class="memdesc:ac730e2a8665f393221200717e97044b0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 3bit right shift (division by 8). <br /></td></tr>
<tr class="separator:ac730e2a8665f393221200717e97044b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a786dd87df96cbcd8247e0ffe5ffeddc1" id="r_a786dd87df96cbcd8247e0ffe5ffeddc1"><td class="memItemLeft" align="right" valign="top"><a id="a786dd87df96cbcd8247e0ffe5ffeddc1" name="a786dd87df96cbcd8247e0ffe5ffeddc1"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_16</b>&#160;&#160;&#160;0x04u</td></tr>
<tr class="memdesc:a786dd87df96cbcd8247e0ffe5ffeddc1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 4bit right shift (division by 16). <br /></td></tr>
<tr class="separator:a786dd87df96cbcd8247e0ffe5ffeddc1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a23a5f56eee5a7a02a7bca8e8acb2f823" id="r_a23a5f56eee5a7a02a7bca8e8acb2f823"><td class="memItemLeft" align="right" valign="top"><a id="a23a5f56eee5a7a02a7bca8e8acb2f823" name="a23a5f56eee5a7a02a7bca8e8acb2f823"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_32</b>&#160;&#160;&#160;0x05u</td></tr>
<tr class="memdesc:a23a5f56eee5a7a02a7bca8e8acb2f823"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 5bit right shift (division by 32). <br /></td></tr>
<tr class="separator:a23a5f56eee5a7a02a7bca8e8acb2f823"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aafd34d5fa4a7608e2709b50753be62fd" id="r_aafd34d5fa4a7608e2709b50753be62fd"><td class="memItemLeft" align="right" valign="top"><a id="aafd34d5fa4a7608e2709b50753be62fd" name="aafd34d5fa4a7608e2709b50753be62fd"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_64</b>&#160;&#160;&#160;0x06u</td></tr>
<tr class="memdesc:aafd34d5fa4a7608e2709b50753be62fd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 6bit right shift (division by 64). <br /></td></tr>
<tr class="separator:aafd34d5fa4a7608e2709b50753be62fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a80ea58834bcaee4a2dc03c47aa3da1e9" id="r_a80ea58834bcaee4a2dc03c47aa3da1e9"><td class="memItemLeft" align="right" valign="top"><a id="a80ea58834bcaee4a2dc03c47aa3da1e9" name="a80ea58834bcaee4a2dc03c47aa3da1e9"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_128</b>&#160;&#160;&#160;0x07u</td></tr>
<tr class="memdesc:a80ea58834bcaee4a2dc03c47aa3da1e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 7bit right shift (division by 128). <br /></td></tr>
<tr class="separator:a80ea58834bcaee4a2dc03c47aa3da1e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c87209c58d1089fc7453a09fa4b213f" id="r_a7c87209c58d1089fc7453a09fa4b213f"><td class="memItemLeft" align="right" valign="top"><a id="a7c87209c58d1089fc7453a09fa4b213f" name="a7c87209c58d1089fc7453a09fa4b213f"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_256</b>&#160;&#160;&#160;0x08u</td></tr>
<tr class="memdesc:a7c87209c58d1089fc7453a09fa4b213f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 8bit right shift (division by 256). <br /></td></tr>
<tr class="separator:a7c87209c58d1089fc7453a09fa4b213f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad5e487f5efc602bbc9a14d3c8b6b9e74" id="r_ad5e487f5efc602bbc9a14d3c8b6b9e74"><td class="memItemLeft" align="right" valign="top"><a id="ad5e487f5efc602bbc9a14d3c8b6b9e74" name="ad5e487f5efc602bbc9a14d3c8b6b9e74"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_DIV_BY_65536</b>&#160;&#160;&#160;0x10u</td></tr>
<tr class="separator:ad5e487f5efc602bbc9a14d3c8b6b9e74"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a774eeb710a4eb58d7f8d67287d9fe7f9" id="r_a774eeb710a4eb58d7f8d67287d9fe7f9"><td class="memItemLeft" align="right" valign="top"><a id="a774eeb710a4eb58d7f8d67287d9fe7f9" name="a774eeb710a4eb58d7f8d67287d9fe7f9"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_MULT_BY_2</b>&#160;&#160;&#160;0x01u</td></tr>
<tr class="memdesc:a774eeb710a4eb58d7f8d67287d9fe7f9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 1bit left shift (multiplication by 2). <br /></td></tr>
<tr class="separator:a774eeb710a4eb58d7f8d67287d9fe7f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add6614aa7d6d3fba44995461a1f4d961" id="r_add6614aa7d6d3fba44995461a1f4d961"><td class="memItemLeft" align="right" valign="top"><a id="add6614aa7d6d3fba44995461a1f4d961" name="add6614aa7d6d3fba44995461a1f4d961"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_MULT_BY_4</b>&#160;&#160;&#160;0x02u</td></tr>
<tr class="memdesc:add6614aa7d6d3fba44995461a1f4d961"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 2bit left shift (multiplication by 4). <br /></td></tr>
<tr class="separator:add6614aa7d6d3fba44995461a1f4d961"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad3584f2e9cbb1e0e78f1d497e51c885" id="r_aad3584f2e9cbb1e0e78f1d497e51c885"><td class="memItemLeft" align="right" valign="top"><a id="aad3584f2e9cbb1e0e78f1d497e51c885" name="aad3584f2e9cbb1e0e78f1d497e51c885"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_MULT_BY_8</b>&#160;&#160;&#160;0x03u</td></tr>
<tr class="memdesc:aad3584f2e9cbb1e0e78f1d497e51c885"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 3bit left shift (multiplication by 8). <br /></td></tr>
<tr class="separator:aad3584f2e9cbb1e0e78f1d497e51c885"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a728f43db60f9e269d82c8570e5e0fcb5" id="r_a728f43db60f9e269d82c8570e5e0fcb5"><td class="memItemLeft" align="right" valign="top"><a id="a728f43db60f9e269d82c8570e5e0fcb5" name="a728f43db60f9e269d82c8570e5e0fcb5"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_MULT_BY_16</b>&#160;&#160;&#160;0x04u</td></tr>
<tr class="memdesc:a728f43db60f9e269d82c8570e5e0fcb5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 4bit left shift (multiplication by 16). <br /></td></tr>
<tr class="separator:a728f43db60f9e269d82c8570e5e0fcb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6277f03cf4a7043fb9c3cd72407e561" id="r_af6277f03cf4a7043fb9c3cd72407e561"><td class="memItemLeft" align="right" valign="top"><a id="af6277f03cf4a7043fb9c3cd72407e561" name="af6277f03cf4a7043fb9c3cd72407e561"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_MULT_BY_32</b>&#160;&#160;&#160;0x05u</td></tr>
<tr class="memdesc:af6277f03cf4a7043fb9c3cd72407e561"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 5bit left shift (multiplication by 32). <br /></td></tr>
<tr class="separator:af6277f03cf4a7043fb9c3cd72407e561"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27cd0723751edf3050f69ed8e6ddd5fb" id="r_a27cd0723751edf3050f69ed8e6ddd5fb"><td class="memItemLeft" align="right" valign="top"><a id="a27cd0723751edf3050f69ed8e6ddd5fb" name="a27cd0723751edf3050f69ed8e6ddd5fb"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_MULT_BY_64</b>&#160;&#160;&#160;0x06u</td></tr>
<tr class="memdesc:a27cd0723751edf3050f69ed8e6ddd5fb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 6bit left shift (multiplication by 64). <br /></td></tr>
<tr class="separator:a27cd0723751edf3050f69ed8e6ddd5fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ecc36b2f3c55e30ca0e4fd851692b2c" id="r_a2ecc36b2f3c55e30ca0e4fd851692b2c"><td class="memItemLeft" align="right" valign="top"><a id="a2ecc36b2f3c55e30ca0e4fd851692b2c" name="a2ecc36b2f3c55e30ca0e4fd851692b2c"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_MULT_BY_128</b>&#160;&#160;&#160;0x07u</td></tr>
<tr class="memdesc:a2ecc36b2f3c55e30ca0e4fd851692b2c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 7bit left shift (multiplication by 128). <br /></td></tr>
<tr class="separator:a2ecc36b2f3c55e30ca0e4fd851692b2c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5975d954f7eec3d4c8cb0c3c0ec331fc" id="r_a5975d954f7eec3d4c8cb0c3c0ec331fc"><td class="memItemLeft" align="right" valign="top"><a id="a5975d954f7eec3d4c8cb0c3c0ec331fc" name="a5975d954f7eec3d4c8cb0c3c0ec331fc"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_MULT_BY_256</b>&#160;&#160;&#160;0x08u</td></tr>
<tr class="memdesc:a5975d954f7eec3d4c8cb0c3c0ec331fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant representing for 8bit left shift (multiplication by 256). <br /></td></tr>
<tr class="separator:a5975d954f7eec3d4c8cb0c3c0ec331fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7bb59dcf2d471bf668c91a9bd6081ea5" id="r_a7bb59dcf2d471bf668c91a9bd6081ea5"><td class="memItemLeft" align="right" valign="top"><a id="a7bb59dcf2d471bf668c91a9bd6081ea5" name="a7bb59dcf2d471bf668c91a9bd6081ea5"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_CONV_MILLISECONDS_TO_SECONCS</b>&#160;&#160;&#160;1000UL</td></tr>
<tr class="separator:a7bb59dcf2d471bf668c91a9bd6081ea5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a491c4d441fa5782d98944b8f2f2e1422" id="r_a491c4d441fa5782d98944b8f2f2e1422"><td class="memItemLeft" align="right" valign="top"><a id="a491c4d441fa5782d98944b8f2f2e1422" name="a491c4d441fa5782d98944b8f2f2e1422"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_CONV_SECONCS_TO_MILLISECONDS</b>&#160;&#160;&#160;1000UL</td></tr>
<tr class="separator:a491c4d441fa5782d98944b8f2f2e1422"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a82195dae7a56308146101e0e0e522101" id="r_a82195dae7a56308146101e0e0e522101"><td class="memItemLeft" align="right" valign="top"><a id="a82195dae7a56308146101e0e0e522101" name="a82195dae7a56308146101e0e0e522101"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_CONV_MICROSECONDS_TO_SECONCS</b>&#160;&#160;&#160;1000000ULL</td></tr>
<tr class="separator:a82195dae7a56308146101e0e0e522101"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b5e70ec48feaa2fcce2f6845400ad17" id="r_a6b5e70ec48feaa2fcce2f6845400ad17"><td class="memItemLeft" align="right" valign="top"><a id="a6b5e70ec48feaa2fcce2f6845400ad17" name="a6b5e70ec48feaa2fcce2f6845400ad17"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_CONV_SECONCS_TO_MICROSECONDS</b>&#160;&#160;&#160;1000000ULL</td></tr>
<tr class="separator:a6b5e70ec48feaa2fcce2f6845400ad17"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19dc9be733634e394988de7ad5b178e1" id="r_a19dc9be733634e394988de7ad5b178e1"><td class="memItemLeft" align="right" valign="top"><a id="a19dc9be733634e394988de7ad5b178e1" name="a19dc9be733634e394988de7ad5b178e1"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_CONV_MILLISECONDS_TO_MICROSECONCS</b>&#160;&#160;&#160;1000UL</td></tr>
<tr class="separator:a19dc9be733634e394988de7ad5b178e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbce1b2caac20f7907ce8512c56888ab" id="r_acbce1b2caac20f7907ce8512c56888ab"><td class="memItemLeft" align="right" valign="top"><a id="acbce1b2caac20f7907ce8512c56888ab" name="acbce1b2caac20f7907ce8512c56888ab"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>KMC_CONV_MICROSECONCS_TO_MILLISECONDS</b>&#160;&#160;&#160;1000UL</td></tr>
<tr class="separator:acbce1b2caac20f7907ce8512c56888ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc6a659fd01ea1267db2d5548de6eb6c" id="r_adc6a659fd01ea1267db2d5548de6eb6c"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#adc6a659fd01ea1267db2d5548de6eb6c">KMC_UNUSED_8_BIT</a>&#160;&#160;&#160;0xffu</td></tr>
<tr class="memdesc:adc6a659fd01ea1267db2d5548de6eb6c"><td class="mdescLeft">&#160;</td><td class="mdescRight">An 8-bit value used to represent an unused parameter.  <br /></td></tr>
<tr class="separator:adc6a659fd01ea1267db2d5548de6eb6c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4b2763d0054575f15e3a1a2db691b0cb" id="r_a4b2763d0054575f15e3a1a2db691b0cb"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a4b2763d0054575f15e3a1a2db691b0cb">KMC_UNUSED_16_BIT</a>&#160;&#160;&#160;0xffffu</td></tr>
<tr class="memdesc:a4b2763d0054575f15e3a1a2db691b0cb"><td class="mdescLeft">&#160;</td><td class="mdescRight">A 16-bit value used to represent an unused parameter.  <br /></td></tr>
<tr class="separator:a4b2763d0054575f15e3a1a2db691b0cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3126e9b2e5b76831b6fde9d6f5e0e2d2" id="r_a3126e9b2e5b76831b6fde9d6f5e0e2d2"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a3126e9b2e5b76831b6fde9d6f5e0e2d2">KMC_UNUSED_32_BIT</a>&#160;&#160;&#160;0xffffffffu</td></tr>
<tr class="memdesc:a3126e9b2e5b76831b6fde9d6f5e0e2d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">A 32-bit value used to represent an unused parameter.  <br /></td></tr>
<tr class="separator:a3126e9b2e5b76831b6fde9d6f5e0e2d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Useful macros for value manipulation and calculations. Constants and conversion factors for use in time and bit manipulation. </p>
<p>This header file defines several macros for working with values, such as getting the string representation of a value, finding the minimum and maximum of two values, and clamping a value within a specified range. Also contains definitions of various constants and conversion factors that are commonly used for bit manipulation and time conversions. <a class="el" href="km_common_defs_8h.html" title="Useful macros for value manipulation and calculations. Constants and conversion factors for use in ti...">kmCommonDefs.h</a></p>
<p><b>Created on</b>: Aug 10, 2019 <br  />
 <b>Author</b>: Krzysztof Moskwa <br  />
 <b>License</b>: GPL-3.0-or-later <br  />
<br  />
 kmCommon library for AVR MCUs <br  />
 <b>Copyright (C) 2019 Krzysztof Moskwa</b></p>
<p>This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.</p>
<p>This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.</p>
<p>You should have received a copy of the GNU General Public License along with this program. If not, see <a href="https://www.gnu.org/licenses/">https://www.gnu.org/licenses/</a>. </p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a6f1271bf1276df4fb7883ea6eaeafbc8" name="a6f1271bf1276df4fb7883ea6eaeafbc8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f1271bf1276df4fb7883ea6eaeafbc8">&#9670;&#160;</a></span>KMC_ARRAY_SIZE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_ARRAY_SIZE</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>a</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">(<span class="keyword">sizeof</span>(a) / <span class="keyword">sizeof</span>((a)[0]))</div>
</div><!-- fragment -->
<p>Retrieve the number of elements in a static array. </p>
<p>This macro computes the number of elements in a given static array. It is useful for determining the size of an array at compile time. Note that this macro should not be used with pointers as it will not give the correct result.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>The array whose size is to be determined. The array must be a statically allocated array.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of elements in the array.</dd></dl>
<dl class="section note"><dt>Note</dt><dd>This macro relies on the <code>sizeof</code> operator and works only with statically allocated arrays. Using this macro with a pointer will result in incorrect output, typically 1.</dd></dl>
<div class="fragment"><div class="line"><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line">    uint8_t my_array[] = {1, 2, 3, 4, 5};</div>
<div class="line">    printf(<span class="stringliteral">&quot;Array size: %zu\n&quot;</span>, ARRAY_SIZE(my_array)); <span class="comment">// Outputs: Array size: 5</span></div>
<div class="line">    <span class="keywordflow">return</span> 0;</div>
<div class="line">}</div>
</div><!-- fragment --> 
</div>
</div>
<a id="adee3c57f4c636e61dcc0d405188b54b2" name="adee3c57f4c636e61dcc0d405188b54b2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adee3c57f4c636e61dcc0d405188b54b2">&#9670;&#160;</a></span>KMC_CLAMP</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_CLAMP</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>x</em></span>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>low</em></span>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>high</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">    ({\</div>
<div class="line">    __typeof__(x) __x = (x); \</div>
<div class="line">    __typeof__(low) __low = (low);\</div>
<div class="line">    __typeof__(high) __high = (high);\</div>
<div class="line">    __x &gt; __high ? __high : (__x &lt; __low ? __low : __x);\</div>
<div class="line">})</div>
</div><!-- fragment -->
<p>Macro to clamp a value within a specified range. </p>
<p>This macro takes a value <code>x</code>, a lower bound <code>low</code>, and an upper bound <code>high</code>. It ensures that <code>x</code> is within the range [<code>low</code>, <code>high</code>] and returns it. If <code>x</code> is less than <code>low</code>, it returns <code>low</code>, and if <code>x</code> is greater than <code>high</code>, it returns <code>high</code>. Otherwise, it returns <code>x</code> itself. </p>

</div>
</div>
<a id="a7a8f4239c5ad41602c910e30c6733b09" name="a7a8f4239c5ad41602c910e30c6733b09"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7a8f4239c5ad41602c910e30c6733b09">&#9670;&#160;</a></span>KMC_INDEX_INCREASE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_INDEX_INCREASE&#160;&#160;&#160;0x01u</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constant representing the unsigned value one used to increase index. </p>
<p>Constant representing the unsigned value one used to decrease index. </p>

</div>
</div>
<a id="adc81a21527ba9134193dd6edc7a714a1" name="adc81a21527ba9134193dd6edc7a714a1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adc81a21527ba9134193dd6edc7a714a1">&#9670;&#160;</a></span>KMC_MAX</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_MAX</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>A</em></span>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>B</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">({ __typeof__(A) __a = (A); __typeof__(B) __b = (B); __a &lt; __b ? __b : __a; })</div>
</div><!-- fragment -->
<p>Macro to find the maximum of two values. </p>
<p>This macro takes two values <code>A</code> and <code>B</code> and returns the larger of the two. It is a type-safe way to find the maximum value between two variables. </p>

</div>
</div>
<a id="af4ae2bd7db4825524ef32840b10ed3ff" name="af4ae2bd7db4825524ef32840b10ed3ff"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af4ae2bd7db4825524ef32840b10ed3ff">&#9670;&#160;</a></span>KMC_MIN</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_MIN</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>A</em></span>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>B</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">({ __typeof__(A) __a = (A); __typeof__(B) __b = (B); __a &lt; __b ? __a : __b; })</div>
</div><!-- fragment -->
<p>Macro to find the minimum of two values. </p>
<p>This macro takes two values <code>A</code> and <code>B</code> and returns the smaller of the two. It is a type-safe way to find the minimum value between two variables. </p>

</div>
</div>
<a id="a74dd4d6ddaafe8bfa3cf7abd7fea92ff" name="a74dd4d6ddaafe8bfa3cf7abd7fea92ff"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74dd4d6ddaafe8bfa3cf7abd7fea92ff">&#9670;&#160;</a></span>KMC_UINT16_TO_BINARY_STRING</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_UINT16_TO_BINARY_STRING</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>byte</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">    ( \</div>
<div class="line">        ((byte) &amp; 0x8000 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x4000 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x2000 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x1000 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x0800 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x0400 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x0200 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x0100 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x80 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x40 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x20 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x10 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x08 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x04 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x02 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x01 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        <span class="charliteral">&#39;\0&#39;</span> \</div>
<div class="line">    )</div>
</div><!-- fragment -->
<p>Convert a uint16_t value to a binary string. </p>
<p>This macro takes a uint16_t value and converts it into a string representation where each bit of the value is represented by either '0' or '1'.</p>
<p>Example usage: </p><div class="fragment"><div class="line">uint16_t value = 0x55AA; <span class="comment">// Example value, 0x55AA in binary is 0101010110101010</span></div>
<div class="line"><span class="keyword">const</span> <span class="keywordtype">char</span> *binaryString = UINT16_TO_BINARY_STRING(value);</div>
<div class="line">printf(<span class="stringliteral">&quot;Binary representation: %s\n&quot;</span>, binaryString);</div>
</div><!-- fragment --><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">byte</td><td>The uint16_t value to be converted. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A string representing the binary value. </dd></dl>

</div>
</div>
<a id="aa7e307660f3dff077b1062a0589df4b5" name="aa7e307660f3dff077b1062a0589df4b5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa7e307660f3dff077b1062a0589df4b5">&#9670;&#160;</a></span>KMC_UINT8_TO_BINARY_STRING</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_UINT8_TO_BINARY_STRING</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>byte</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">    ( \</div>
<div class="line">        ((byte) &amp; 0x80 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x40 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x20 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x10 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x08 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x04 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x02 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        ((byte) &amp; 0x01 ? <span class="charliteral">&#39;1&#39;</span> : <span class="charliteral">&#39;0&#39;</span>), \</div>
<div class="line">        <span class="charliteral">&#39;\0&#39;</span> \</div>
<div class="line">    )</div>
</div><!-- fragment -->
<p>Convert a uint8_t value to a binary string. </p>
<p>This macro takes a uint8_t value and converts it into a string representation where each bit of the value is represented by either '0' or '1'.</p>
<p>Example usage: </p><div class="fragment"><div class="line">uint8_t value = 0xAA; <span class="comment">// Example value, 0xAA in binary is 10101010</span></div>
<div class="line"><span class="keyword">const</span> <span class="keywordtype">char</span> *binaryString = UINT8_TO_BINARY_STRING(value);</div>
<div class="line">printf(<span class="stringliteral">&quot;Binary representation: %s\n&quot;</span>, binaryString);</div>
</div><!-- fragment --><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">byte</td><td>The uint8_t value to be converted. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A string representing the binary value. </dd></dl>

</div>
</div>
<a id="a4b2763d0054575f15e3a1a2db691b0cb" name="a4b2763d0054575f15e3a1a2db691b0cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4b2763d0054575f15e3a1a2db691b0cb">&#9670;&#160;</a></span>KMC_UNUSED_16_BIT</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_UNUSED_16_BIT&#160;&#160;&#160;0xffffu</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A 16-bit value used to represent an unused parameter. </p>
<p>This constant defines a 16-bit hexadecimal value (0xFFFFu) that is typically used to indicate that a parameter or variable is not in use. </p>

</div>
</div>
<a id="a3126e9b2e5b76831b6fde9d6f5e0e2d2" name="a3126e9b2e5b76831b6fde9d6f5e0e2d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3126e9b2e5b76831b6fde9d6f5e0e2d2">&#9670;&#160;</a></span>KMC_UNUSED_32_BIT</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_UNUSED_32_BIT&#160;&#160;&#160;0xffffffffu</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A 32-bit value used to represent an unused parameter. </p>
<p>This constant defines a 32-bit hexadecimal value (0xFFFFFFFFu) that is often used to signify that a parameter or variable is not in use. </p>

</div>
</div>
<a id="adc6a659fd01ea1267db2d5548de6eb6c" name="adc6a659fd01ea1267db2d5548de6eb6c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adc6a659fd01ea1267db2d5548de6eb6c">&#9670;&#160;</a></span>KMC_UNUSED_8_BIT</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_UNUSED_8_BIT&#160;&#160;&#160;0xffu</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>An 8-bit value used to represent an unused parameter. </p>
<p>This constant defines an 8-bit hexadecimal value (0xFFu) that is commonly used to indicate that a parameter or variable is not in use. </p>

</div>
</div>
<a id="ad80e356747d976a14f58ae2cd88bd75e" name="ad80e356747d976a14f58ae2cd88bd75e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad80e356747d976a14f58ae2cd88bd75e">&#9670;&#160;</a></span>KMC_VALUE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_VALUE</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><a class="code hl_define" href="#aae9131e49e1a70ddd3553c9675f5ffcb">KMC_VALUE_TO_STRING</a>(x)</div>
<div class="ttc" id="akm_common_defs_8h_html_aae9131e49e1a70ddd3553c9675f5ffcb"><div class="ttname"><a href="#aae9131e49e1a70ddd3553c9675f5ffcb">KMC_VALUE_TO_STRING</a></div><div class="ttdeci">#define KMC_VALUE_TO_STRING(x)</div><div class="ttdoc">Converts a value to its string representation.</div><div class="ttdef"><b>Definition</b> kmCommonDefs.h:45</div></div>
</div><!-- fragment -->
<p>Macro to get the string representation of a value. </p>
<p>This macro uses <code>VALUE_TO_STRING</code> to convert the value <code>x</code> to its string representation. For example, if you pass a variable named <code>myVar</code> with the value 42, <code>VALUE(myVar)</code> will yield the string "myVar=42". </p>

</div>
</div>
<a id="aae9131e49e1a70ddd3553c9675f5ffcb" name="aae9131e49e1a70ddd3553c9675f5ffcb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aae9131e49e1a70ddd3553c9675f5ffcb">&#9670;&#160;</a></span>KMC_VALUE_TO_STRING</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_VALUE_TO_STRING</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="preprocessor">#x</span></div>
</div><!-- fragment -->
<p>Converts a value to its string representation. </p>
<p>This macro converts the given value <code>x</code> to its string representation. For example, if you pass 42 as <code>x</code>, it will be converted to the string "42". </p>

</div>
</div>
<a id="a324c0391d0bbdc4ae0e89bbf2a12304d" name="a324c0391d0bbdc4ae0e89bbf2a12304d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a324c0391d0bbdc4ae0e89bbf2a12304d">&#9670;&#160;</a></span>KMC_VAR_NAME_VALUE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define KMC_VAR_NAME_VALUE</td>
          <td>(</td>
          <td class="paramtype"></td>          <td class="paramname"><span class="paramname"><em>var</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="preprocessor">#var &quot;=&quot;  KMC_VALUE(var)</span></div>
</div><!-- fragment -->
<p>Macro to get a variable name and its value as a string. </p>
<p>This macro takes a variable <code>var</code> and returns a string that includes the variable name followed by its value, separated by an equal sign (=). For example, if you pass <code>myVar</code> with the value 42, <code>VAR_NAME_VALUE(myVar)</code> will yield the string "myVar=42". </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="km_common_defs_8h.html">kmCommonDefs.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.12.0 </li>
  </ul>
</div>
</body>
</html>
